%{!?perl_vendorlib:  %define perl_vendorlib  %(eval "`%{__perl} -V:installvendorlib`" ; echo $installvendorlib)}
%{!?perl_vendorarch: %define perl_vendorarch %(eval "`%{__perl} -V:installvendorarch`"; echo $installvendorarch)}
%{!?perl_version:    %define perl_version    %(eval "`%{__perl} -V:version`"          ; echo $version)}

%define prog      amavisd
%define short     amavis


Summary:          A high-performance interface between MTAs and content checkers
Name:             amavisd-new
Version:          2.6.5
Release:          1%{?dist}%{?pext}
License:          GPL
Group:            System Environment/Daemons
Source0:          http://www.ijs.si/software/%{prog}/%{name}-%{version}.tar.gz
Source1:          %{prog}.init
Source2:          %{prog}.sysconfig
Source3:          %{prog}-snmp.init
Source4:          %{prog}-snmp.sysconfig
Patch0:           %{name}-2.6.4-config.patch
Patch1:           %{name}-2.6.4-readme.patch
URL:              http://www.ijs.si/software/%{prog}/
Buildroot:        %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Vendor:           Mark Martinec <mark.martinec@ijs.si>
Requires:         perl(:MODULE_COMPAT_%{perl_version})
Requires:         perl(Archive::Zip) >= 1.14
Requires:         perl(Compress::Zlib) >= 1.35
Requires:         perl(Compress::Raw::Zlib) >= 2.017
Requires:         perl(Convert::TNEF)
Requires:         perl(Convert::UUlib) >= 1.08
Requires:         perl(Digest::MD5) >= 2.22
Requires:         perl(IO::Stringy)
Requires:         perl(Mail::SpamAssassin)
Requires:         perl(MIME::Base64)
Requires:         perl(MIME::Parser)
Requires:         perl(Mail::DKIM) >= 0.31
Requires:         perl(Mail::Internet) >= 1.58
Requires:         perl(Net::Server) >= 0.88
Requires:         perl(Time::HiRes) >= 1.49
Requires:         perl(Unix::Syslog)
Requires:         bzip2 cpio file gzip unzip
Requires(pre):    /usr/sbin/groupadd /usr/sbin/useradd
Requires(post):   /sbin/chkconfig
Requires(preun):  /sbin/chkconfig /sbin/service
Requires(postun): /sbin/service
BuildRequires:    sendmail-devel

%description
Amavisd-new is a high-performance and reliable interface between MTAs and
one or more content checkers, including virus scanners, and/or SpamAssasin.
It talks to the MTA via (E)SMTP or LMTP, or by using helper programs. No
timing gaps exist in the design, which could cause a mail loss. Usually it
gets positioned at or near a central mailer, not necessarily where the user
mailboxes and final delivery takes place.


%package          milter
Summary:          The Milter interface for %{name}
Group:            System Environment/Daemons
Requires:         %{name} = %{version}-%{release}
Requires(preun):  /sbin/service
Requires(postun): /sbin/service

%description      milter
The %{name}-milter package contains the sendmail milter interface for
%{name}.


%package          snmp
Summary:          The SNMP interface for %{name}
Group:            System Environment/Daemons
Requires:         %{name} = %{version}-%{release}
Requires(post):   /sbin/chkconfig
Requires(preun):  /sbin/chkconfig /sbin/service
Requires(postun): /sbin/service

%description      snmp
The %{name}-snmp package contains a true SNMP agent and a MIB, useful
for monitoring the health of the content filtering system, its performance
and mail characteristics.


%prep
%setup -q
%patch0 -p1
%patch1 -p0

# Fix paths
for FILE in %{prog}               \
	    %{prog}-agent         \
	    %{prog}-nanny         \
	    %{prog}-release       \
	    %{prog}-snmp-subagent \
	    %{prog}.conf          \
	    %{prog}.conf-default  \
	    %{prog}.conf-sample   \
	    helper-progs/%{short}.pl; do
  %{__sed} -i -e "s#/var/%{short}#%{_localstatedir}/lib/%{short}#g" ${FILE}
done

# Filter requires
%{__cat} << \_EOF_ >%{name}-req
#!/bin/sh
%{__perl_requires} $* | \
	%{__sed} -e '/perl(DBD::mysql)/d' -e '/perl(DBI)/d'
_EOF_

%define __perl_requires %{_builddir}/%{name}-%{version}/%{name}-req
%{__chmod} +x %{name}-req


%build
pushd helper-progs
%configure \
	ac_cv_path_LIBMILTER="%{_libdir}/libmilter.a"     \
	ac_cv_path_LIBSM="%{_libdir}/libsm.a"             \
	--with-user=%{short}                              \
	--with-sendmail=%{_sbindir}/sendmail              \
	--with-runtime-dir=%{_localstatedir}/lib/%{short} \
	--with-sockname=%{_localstatedir}/lib/%{short}/%{prog}.sock

%{__make} %{?_smp_mflags}
popd


%install
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_initrddir}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_bindir}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_sbindir}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{perl_vendorlib}
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_datadir}/snmp/mibs
%{__mkdir_p} ${RPM_BUILD_ROOT}%{_localstatedir}/lib/%{short}/{db,tmp,var,virus}

for FILE in %{prog}-agent         \
	    %{prog}-nanny         \
	    %{prog}-release       \
	    *.pl                  \
	    helper-progs/%{short} \
	    helper-progs/*.pl; do
  %{__install} -m 0755 ${FILE}    ${RPM_BUILD_ROOT}%{_bindir}
done

for FILE in %{prog}               \
	    helper-progs/%{short}-milter; do
  %{__install} -m 0755 ${FILE}    ${RPM_BUILD_ROOT}%{_sbindir}
done

%{__install} -m 0755 %{prog}-snmp-subagent ${RPM_BUILD_ROOT}%{_sbindir}/%{prog}-snmp

%{__install} -m 0755 %{SOURCE1}   ${RPM_BUILD_ROOT}%{_initrddir}/%{prog}
%{__install} -m 0644 %{SOURCE2}   ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/%{prog}

%{__install} -m 0755 %{SOURCE3}   ${RPM_BUILD_ROOT}%{_initrddir}/%{prog}-snmp
%{__install} -m 0644 %{SOURCE4}   ${RPM_BUILD_ROOT}%{_sysconfdir}/sysconfig/%{prog}-snmp

%{__install} -m 0640 %{prog}.conf ${RPM_BUILD_ROOT}%{_sysconfdir}

%{__install} -m 0644 *.pm         ${RPM_BUILD_ROOT}%{perl_vendorlib}
%{__install} -m 0644 *MIB.txt     ${RPM_BUILD_ROOT}%{_datadir}/snmp/mibs


%pre
if ! getent group  %{short} >/dev/null 2>&1; then
  /usr/sbin/groupadd -r %{short}
fi
if ! getent passwd %{short} >/dev/null 2>&1; then
  /usr/sbin/useradd  -r -g %{short}       \
	-d %{_localstatedir}/lib/%{short} \
	-c "Amavis Service user"          \
	-s /sbin/nologin %{short}
fi
exit 0			# Always pass


%post
if ! getent services %{short} >/dev/null 2>&1; then
  echo -e "%{short}\t\t10024/tcp" >>%{_sysconfdir}/services
fi

/sbin/chkconfig --add %{prog}

%post milter
if ! getent services %{short}-milter >/dev/null 2>&1; then
  echo -e "%{short}-milter\t10026/tcp" >>%{_sysconfdir}/services
fi

%post snmp
/sbin/chkconfig --add %{prog}-snmp


%preun
if [ $1 -eq 0 ]; then	# Remove
  /sbin/service %{prog} stop >/dev/null 2>&1
  /sbin/chkconfig --del %{prog}
fi

%preun milter
if [ $1 -eq 0 ]; then	# Remove
  /sbin/service %{prog} stop >/dev/null 2>&1
fi

%preun snmp
if [ $1 -eq 0 ]; then	# Remove
  /sbin/service %{prog}-snmp stop >/dev/null 2>&1
  /sbin/chkconfig --del %{prog}-snmp
fi


%postun
if [ $1 -ge 1 ]; then	# Upgrade
  /sbin/service %{prog} condrestart >/dev/null 2>&1 || :
fi

%postun milter
if [ $1 -ge 1 ]; then	# Upgrade
  /sbin/service %{prog} condrestart >/dev/null 2>&1 || :
fi

%postun snmp
if [ $1 -ge 1 ]; then	# Upgrade
  /sbin/service %{prog}-snmp condrestart >/dev/null 2>&1 || :
fi


%clean
[ -n "${RPM_BUILD_ROOT}" -a "${RPM_BUILD_ROOT}" != "/" ] && %{__rm} -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc INSTALL LICENSE *README* RELEASE_NOTES TODO
%doc *.conf* *.patch *.schema
%attr(640,root,%{short}) %config(noreplace) %{_sysconfdir}/%{prog}.conf
%config(noreplace) %{_sysconfdir}/sysconfig/%{prog}
%{_initrddir}/%{prog}
%{_bindir}/%{short}
%{_bindir}/%{short}.pl
%{_bindir}/%{prog}-agent
%{_bindir}/%{prog}-nanny
%{_bindir}/%{prog}-release
%{_bindir}/p0f-analyzer.pl
%{_sbindir}/%{prog}
%{perl_vendorlib}/*
%attr(750,%{short},%{short}) %dir %{_localstatedir}/lib/%{short}
%attr(750,%{short},%{short}) %dir %{_localstatedir}/lib/%{short}/db
%attr(750,%{short},%{short}) %dir %{_localstatedir}/lib/%{short}/tmp
%attr(750,%{short},%{short}) %dir %{_localstatedir}/lib/%{short}/var
%attr(750,%{short},%{short}) %dir %{_localstatedir}/lib/%{short}/virus

%files milter
%defattr(-,root,root)
%{_sbindir}/%{short}-milter

%files snmp
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/sysconfig/%{prog}-snmp
%{_initrddir}/%{prog}-snmp
%{_sbindir}/%{prog}-snmp
%config(noreplace) %{_datadir}/snmp/mibs/AMAVIS-MIB.txt


%changelog
* Mon May 09 2011 Peter Pramberger <peterpramb@member.fsf.org> - 2.6.5-1
- New version (2.6.5)

* Thu Jul 30 2009 Peter Pramberger <peterpramb@member.fsf.org> - 2.6.4-1
- New version (2.6.4)

* Fri May 29 2009 Peter Pramberger <peterpramb@member.fsf.org> - 2.6.3-2
- Added fix for startup aborts with disabled spam checking

* Fri May 08 2009 Peter Pramberger <peterpramb@member.fsf.org> - 2.6.3-1
- New version (2.6.3)

* Fri Dec 19 2008 Peter Pramberger <peterpramb@member.fsf.org> - 2.6.2-1
- New version (2.6.2)

* Tue Nov 18 2008 Peter Pramberger <peterpramb@member.fsf.org> - 2.6.1-1
- Upgrade version (2.6.1)

* Tue Oct 09 2007 peter.pramberger@member.fsf.org 2.5.2-7
- new version (2.5.2)

* Wed Nov 22 2006 peter.pramberger@member.fsf.org 2.4.4-6
- new version (2.4.4)

* Thu Nov 02 2006 peter.pramberger@member.fsf.org 2.4.3-5
- new version (2.4.3)

* Tue Jun 27 2006 peter.pramberger@member.fsf.org
- new version (2.4.2)

* Sat Jan 28 2006 peter.pramberger@member.fsf.org
- created
